#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();                          // called this way, it uses the default address 0x40

#define tempSensor A0                                                             //create a const. variable named "tempSensor" with value A0.

#define red 1                                                                     //create a const. variable named "red" with value 0.
#define green 2                                                                   //create a const. variable named "green" with value 1.
#define blue 0                                                                    //create a const. variable named "blue" with value 2.

int sensorReading = 0;                                                            //create a variable named "sensorReading" with initial value 0.
float volts = 0;                                                                  //create a variable named "volts" with initial value 0.
float temp = 0;                                                                   //create a variable named "temp" with initial value 0.
int mapped = 0;                                                                   //create a variable named "mapped" with initial value 0.

void setup() {

  pwm.begin();                                                                    //Setups the I2C interface and hardware.
  delay(10);                                                                      //wait 10 milliseconds.

  pinMode(tempSensor, INPUT);                                                     //set the tempSensor pin as an INPUT pin to read the sensor data.
  Serial.begin(9600);                                                             //start the hardware serial communication.
}


void loop() {

  sensorReading = analogRead(tempSensor);                                        //read the sensor data and assign the value in the "sensorReading" variable.
  volts = (sensorReading / 1024.0) * 5.0;                                        //conversion to volts
  temp = volts * 100.0;                                                          //conversion to temp Celsius
  constrain(temp, 30, 45);                                                       //force the temp variable's value to be between 30-45.
  mapped = map(temp, 30, 45, 500, 4000);                                         //remap the "temp" variable value from 30-45 to 500-4000. and save the new value inside the "mapped" variable.
  pwm.setPin(red, mapped);                                                       //write the "mapped" variable value to the red LED. the red LED brightness level will increase and decrease according to the "mapped" variable value.
  pwm.setPin(blue, 4010-mapped);                                                 //subtract the "mapped" variable value form 4010 and write the equal value to the blue LED, this technique will decrease the brightness of the blue LED while increasing the red LED.

  Serial.print("celesius is equal  ");                                           // write "celesius is equal  " on the serial monitor.
  Serial.print(temp);                                                            //print the "temp" variable value on the serial monitor.
  Serial.print("        mapped value is equal   ");                              // write "        mapped value is equal   " on the serial monitor.
  Serial.println(mapped);                                                        //print the "mapped" variable value on the serial monitor.
  delay(1);                                                                      //wait one millisecond.

}
